<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-public](./kibana-plugin-public.md) &gt; [UiSettingsClient](./kibana-plugin-public.uisettingsclient.md)

## UiSettingsClient class


<b>Signature:</b>

```typescript
export declare class UiSettingsClient 
```

## Constructors

|  Constructor | Modifiers | Description |
|  --- | --- | --- |
|  [(constructor)(params)](./kibana-plugin-public.uisettingsclient.(constructor).md) |  | Constructs a new instance of the <code>UiSettingsClient</code> class |

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [get(key, defaultOverride)](./kibana-plugin-public.uisettingsclient.get.md) |  | Gets the value for a specific uiSetting. If this setting has no user-defined value then the <code>defaultOverride</code> parameter is returned (and parsed if setting is of type "json" or "number). If the parameter is not defined and the key is not defined by a uiSettingDefaults then an error is thrown, otherwise the default is read from the uiSettingDefaults. |
|  [get$(key, defaultOverride)](./kibana-plugin-public.uisettingsclient.get$.md) |  | Gets an observable of the current value for a config key, and all updates to that config key in the future. Providing a <code>defaultOverride</code> argument behaves the same as it does in \#get() |
|  [getAll()](./kibana-plugin-public.uisettingsclient.getall.md) |  | Gets the metadata about all uiSettings, including the type, default value, and user value for each key. |
|  [getSaved$()](./kibana-plugin-public.uisettingsclient.getsaved$.md) |  | Returns an Observable that notifies subscribers of each update to the uiSettings, including the key, newValue, and oldValue of the setting that changed. |
|  [getUpdate$()](./kibana-plugin-public.uisettingsclient.getupdate$.md) |  | Returns an Observable that notifies subscribers of each update to the uiSettings, including the key, newValue, and oldValue of the setting that changed. |
|  [getUpdateErrors$()](./kibana-plugin-public.uisettingsclient.getupdateerrors$.md) |  | Returns an Observable that notifies subscribers of each error while trying to update the settings, containing the actual Error class. |
|  [isCustom(key)](./kibana-plugin-public.uisettingsclient.iscustom.md) |  | Returns true if the setting is not a part of the uiSettingDefaults, but was either added directly via <code>set()</code>, or is an unknown setting found in the uiSettings saved object |
|  [isDeclared(key)](./kibana-plugin-public.uisettingsclient.isdeclared.md) |  | Returns true if the key is a "known" uiSetting, meaning it is either defined in the uiSettingDefaults or was previously added as a custom setting via the <code>set()</code> method. |
|  [isDefault(key)](./kibana-plugin-public.uisettingsclient.isdefault.md) |  | Returns true if the setting has no user-defined value or is unknown |
|  [isOverridden(key)](./kibana-plugin-public.uisettingsclient.isoverridden.md) |  | Returns true if a settings value is overridden by the server. When a setting is overridden its value can not be changed via <code>set()</code> or <code>remove()</code>. |
|  [overrideLocalDefault(key, newDefault)](./kibana-plugin-public.uisettingsclient.overridelocaldefault.md) |  | Overrides the default value for a setting in this specific browser tab. If the page is reloaded the default override is lost. |
|  [remove(key)](./kibana-plugin-public.uisettingsclient.remove.md) |  | Removes the user-defined value for a setting, causing it to revert to the default. This method behaves the same as calling <code>set(key, null)</code>, including the synchronization, custom setting, and error behavior of that method. |
|  [set(key, val)](./kibana-plugin-public.uisettingsclient.set.md) |  | Sets the value for a uiSetting. If the setting is not defined in the uiSettingDefaults it will be stored as a custom setting. The new value will be synchronously available via the <code>get()</code> method and sent to the server in the background. If the request to the server fails then a toast notification will be displayed and the setting will be reverted it its value before <code>set()</code> was called. |
|  [stop()](./kibana-plugin-public.uisettingsclient.stop.md) |  | Prepares the uiSettingsClient to be discarded, completing any update$ observables that have been created. |

