<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-server](./kibana-plugin-server.md) &gt; [ElasticsearchErrorHelpers](./kibana-plugin-server.elasticsearcherrorhelpers.md)

## ElasticsearchErrorHelpers class

Helpers for working with errors returned from the Elasticsearch service.Since the internal data of errors are subject to change, consumers of the Elasticsearch service should always use these helpers to classify errors instead of checking error internals such as `body.error.header[WWW-Authenticate]`

<b>Signature:</b>

```typescript
export declare class ElasticsearchErrorHelpers 
```

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [decorateNotAuthorizedError(error, reason)](./kibana-plugin-server.elasticsearcherrorhelpers.decoratenotauthorizederror.md) | <code>static</code> |  |
|  [isNotAuthorizedError(error)](./kibana-plugin-server.elasticsearcherrorhelpers.isnotauthorizederror.md) | <code>static</code> |  |

## Example

Handle errors

```js
try {
  await client.asScoped(request).callAsCurrentUser(...);
} catch (err) {
  if (ElasticsearchErrorHelpers.isNotAuthorizedError(err)) {
    const authHeader = err.output.headers['WWW-Authenticate'];
  }

```

